#ifndef __MFDVARHANDLER_H
#define __MFDVARHANDLER_H

#include "mfdvariable.h"

#define MAXVIEWMODES 10
#define MAXPOINTERS 30

class MFDvarhandler{
private:
	class MFDvariable *firstitem;
	class MFDvariable *lastitem;
	
	//MFDvariable *pointers[MAXPOINTERS];// Arbitrary array sizes - any answer?
	//int startvarpointer[MAXVIEWMODES]; // Holds starts for mode position and number of variables
	//int endvarpointer[MAXVIEWMODES];//And ends
	class MFDvariable *currvariable[5]; //The current variable for each viewmode
public:
	void addtolist(MFDvariable *item);
	void removefromlist(MFDvariable *item);
	void setprevcurrent(int viewmode);
	void setnextcurrent(int viewmode);
	void saveallvariables(FILEHANDLE scn);
	bool loadallvariables(FILEHANDLE scn);
	MFDvariable* getcurrent(int viewmode);
	MFDvarhandler();//Sets MFDvariable list to 0
	~MFDvarhandler();//Deletes all MFDvariables created through the class
	void deleteall(); // Deletes and resets MFD variable system - typically following inability to assign space
	void resetvars();
};

#endif