#define STRICT

#include <windows.h>
#include <stdio.h>
#include <math.h>
#include "orbitersdk.h"
#include "mfd.h"
#include "intercept.h"
#include "mapfunction.h"
#include "mfdvarhandler.h"
#include "basefunction.h"
#include "viewstate.h"
#include "transxstate.h"

class mapfunction *transxstate::mappointer=NULL;
bool transxstate::statelistinitflag=false;


double debug;

/*basefunction *transxstate::GetCurrFunction()
{
	return currfunction;
}*/

MFDvarhandler *transxstate::GetVarhandler(int currvarfunction)
{
	if (currvarfunction<1 || currvarfunction>numfunctions) currvarfunction=1;
	int presentposition=(fnbaseposition+currvarfunction-1)%NUMFUNCTIONS;
	class basefunction *cfunction=functionlist[presentposition];
	if (cfunction==NULL) cfunction=functionlist[fnbaseposition];
	return cfunction->getvariablehandler();
}

MFDvariable *transxstate::GetCurrVariable(int currvarfunction,int currviewmode)
{
	if (currvarfunction<1 || currvarfunction>numfunctions) currvarfunction=1;
	int presentposition=(fnbaseposition+currvarfunction-1)%NUMFUNCTIONS;
	class basefunction *cfunction=functionlist[presentposition];
	if (cfunction==NULL) cfunction=functionlist[fnbaseposition];
	return cfunction->getcurrentvariable(currviewmode);
}

/*bool transxstate::gettransxstate(UINT mfd, class transxstate **state, TransxMFD *tmfdpointer)
{
	if (!statelistinitflag) return false;
	*state=mfdstatelist[mfd];
	if (*state==NULL) return false;
	(*state)->mfdpointer=tmfdpointer;
	return true;
}*/

void transxstate::createmapfunction()
{
	if (mappointer==NULL)
	{
		mappointer=new mapfunction();//Create a new mapfunction
	}
}



int transxstate::movetonextfunction(int curvarfunction)
{
	//Check for validity of passed curvarfunction
	if (curvarfunction<1 || curvarfunction>numfunctions)
	{//Invalid value, reset to valid value
		return 1;
	}
	int presentfunction=(curvarfunction+fnbaseposition-1)%NUMFUNCTIONS;
	int nextfunction=(curvarfunction+fnbaseposition)%NUMFUNCTIONS;
	class basefunction *cfunction=functionlist[presentfunction];

	OBJHANDLE tmajor,tminor,actualhmajor;
	cfunction->updateplan();
	cfunction->handlesfornextfunction(&tmajor,&tminor);
	if (nextfunction!=(fnbaseposition+numfunctions)%NUMFUNCTIONS)//if not the last function
	{
		//check if function matches - if not, delete it and its following functions
		actualhmajor=functionlist[nextfunction]->gethmajor();
		if (actualhmajor==tmajor)
		{//function is still legal, just move to it
			return curvarfunction+1;
		}
		else
		{//function does not match, therefore
			//Move all functions beyond this point to the delete list
			int temp=nextfunction;
			int terminate=(fnbaseposition+numfunctions)%NUMFUNCTIONS;
			do
			{
				todeletelist[enddellist++]=functionlist[temp];
				functionlist[temp++]=NULL;
				if (currcalcfunction==temp) currcalcfunction=terminate;
				if (temp==NUMFUNCTIONS)temp=0;
				if (enddellist==NUMFUNCTIONS)enddellist=0;
				numfunctions--;
			}
			while (temp!=terminate);
			addaction(0);
		}
	}
	//Will now be the last function!
	if (numfunctions==NUMFUNCTIONS) return curvarfunction;//Buffer is full - cannot add more
	if (tmajor==NULL) return curvarfunction;//No new legal function to create, so return
	//Create new function, and move to it
	class basefunction *temp=new basefunction(this,nextfunction,tmajor,tminor);
	int prevplantype,prevplan,targettype;
	cfunction->getplanstate(&prevplantype,&prevplan,&targettype);
	temp->setnextplanstate(prevplantype,prevplan,targettype);
	functionlist[nextfunction]=temp;
	numfunctions++;
	return curvarfunction+1;
}


bool transxstate::checkdelete()
{
	if (enddellist==deleteposition) return false;
	delete todeletelist[deleteposition];
	todeletelist[deleteposition]=NULL;
	deleteposition++;
	if (deleteposition==NUMFUNCTIONS) deleteposition=0;
	addaction(0);
	return true;
}


int transxstate::movetopreviousfunction(int curvarfunction)
{
	if (curvarfunction<2) return 1;//At first function, cannot move back
	int presentposition=(curvarfunction+fnbaseposition-1)%NUMFUNCTIONS;
	class basefunction *cfunction=functionlist[presentposition];
	if (cfunction==NULL) return numfunctions;
	cfunction->updateplan();
	return curvarfunction-1;
}

int transxstate::inc_viewmode(int currfunction,int currview)
{
	int presentposition=(currfunction+fnbaseposition-1)%NUMFUNCTIONS;
	class basefunction *cfunction=functionlist[presentposition];
	if (cfunction==NULL) return 2;//Just return anyway
	return cfunction->calcnewview(currview);
}

/*int transxstate::getvariableviewmode()
{
	return currfunction->getvariableviewmode();
}*/

void transxstate::dolowpriaction()
{

	if (!initflag) return;//do not attempt to run if initialisation incomplete
	if (checkdelete()) return;
	//Send back most of the time, to reduce system load
	if (actionframe>0)
	{
		actionframe--;
		addaction(0);
		return;
	}
	actionframe=10;
	if (currcalcfunction==-1)
	{
		currcalcfunction=fnbaseposition;
		checkbasefunction();
	}
	VECTOR3 temp;
	if (functionlist[currcalcfunction]==NULL) currcalcfunction=fnbaseposition;//Failsafe
	functionlist[currcalcfunction]->calculate(&temp);
	if (currcalcfunction==(fnbaseposition+numfunctions-1)%NUMFUNCTIONS)
	{//at last function
		currcalcfunction=-1;
		return;
	}
	currcalcfunction++;
	if (currcalcfunction==NUMFUNCTIONS) currcalcfunction=0;
	addaction(0);
}


bool transxstate::checkbasefunction()
{
	if (functionlist[fnbaseposition]->soistatus()) return false;//didn't delete anything
	//Now know that current base function is seeking a successor!
	int successor=(fnbaseposition+1)%NUMFUNCTIONS;
	if (functionlist[successor]==NULL) return false;//No successor
	if (!functionlist[successor]->soistatus()) return false;//Successor no better
	//Delete the current function
	//Move pointer to first function to the delete list
	todeletelist[enddellist]=functionlist[fnbaseposition];
	enddellist++;
	currcalcfunction=successor;//Just ensure this is very legal
	functionlist[fnbaseposition++]=NULL;
	viewstate::downshift();//Tell all viewstates to move their position numbers down 1
	if (fnbaseposition==NUMFUNCTIONS)fnbaseposition=0;
	if (enddellist==NUMFUNCTIONS)enddellist=0;
	numfunctions--;
	return true;
}




void transxstate::deletemapfunction()
{
	if (mappointer!=NULL)
	{
		delete mappointer;
	}
	mappointer=NULL;
}

class TransxMFD *transxstate::GetMFDpointer()
{
	return mfdpointer;
}


void transxstate::updateownfocusvessel(OBJHANDLE newfocus)
{
	for (int a=0;a<NUMFUNCTIONS;a++)
	{
		if (functionlist[a]!=NULL) functionlist[a]->sethcraft(newfocus);
	}
}



void transxstate::savecurrent(FILEHANDLE scn)

{
	if (saveflag) return;
	saveflag=true;
	//Save each function
	char buffer[20];//Too big, but who cares!
	strcpy(buffer,"FNumber");
	oapiWriteScenario_int(scn,buffer,numfunctions);
	int final=(fnbaseposition+numfunctions)%NUMFUNCTIONS;
	int a=fnbaseposition;
	do
	{
		if (functionlist[a]!=NULL) functionlist[a]->saveself(scn);
		a=(++a)%NUMFUNCTIONS;
	}
	while (a!=final);
}



void transxstate::restoresave(FILEHANDLE scn)
{
	char *buffer,*member;
	PARSER parser;
	int length;
	if (!oapiReadScenario_nextline(scn,buffer)) return;
	parser.parseline(buffer);
	if (parser.getlineelement(1,&member,&length))
	{
		sscanf(member,"%i",&numfunctions);
	}
	else
	{
		return;
	}
	OBJHANDLE thmajor=oapiGetGbodyByIndex(0);//should be the central sun - only a safe stand-in anyway until real values loaded
	if (numfunctions<0 || numfunctions>100) return;
	bool success=true;
	int a;
	for (a=0;a<NUMFUNCTIONS;a++) functionlist[a]=NULL;
	for (a=0;a<numfunctions;a++)
	{
		functionlist[a]=new basefunction(this,a,thmajor,NULL);
		if (functionlist[a]==NULL)
		{
			success=false;
			break;
		}
		functionlist[a]->initialisevars();
	}
	if (success)
	{
		for (a=0;a<numfunctions;a++)
		{
			functionlist[a]->restoreself(scn);
		}
	}
	else
	{
		for (a=0;a<NUMFUNCTIONS;a++)
		{
			if (functionlist[a]!=NULL)
			{
				delete functionlist[a];
			}
		}
	}
	currcalcfunction=-1;
}



transxstate::transxstate()
{
	createmapfunction();
	for (int a=0;a<NUMFUNCTIONS;a++)
	{
		functionlist[a]=NULL;
		todeletelist[a]=NULL;
	}
	enddellist=deleteposition=0;
	initflag=false;
	helpsystem=false;//Switch help system off by default
	mfdactive=true;
	currcalcfunction=0;
	fnbaseposition=0;
	numfunctions=0;
	functionswitch=true;
	saveflag=false;
	actionframe=0;
	eastereggswitch=int(floor(long(oapiGetSimMJD()*86400)%5-1));
}


/*void transxstate::deletenonactivetransxstate()
{
	for (int a=0;a<20;a++)
	{
		if (mfdstatelist[a]!=NULL)
		{
			if (mfdstatelist[a]->mfdactive==false)
			{
				delete mfdstatelist[a];
				mfdstatelist[a]=NULL;
			}
		}
	}
}*/



bool transxstate::initfunctions()//sets up transxstate if no saved state to reload
{
	
	//Create some default values for these functions
	OBJHANDLE thmajor,thminor;
	thminor=NULL;
	thmajor=mappointer->getcurrbody();

	//Initialise functions
	*functionlist=new basefunction(this,0,thmajor,thminor);//basefunction in first slot
	if (*functionlist==NULL) return false;
	numfunctions=1;//total number of functions
	currcalcfunction=-1;
	fnbaseposition=0;//where first function is found in list
	return true;
}

basefunction *transxstate::getpreviousfunction(int positionnumber)
{
	if (positionnumber<0 || positionnumber>=NUMFUNCTIONS) return NULL;
	if (positionnumber==0)
	{
		positionnumber=NUMFUNCTIONS-1;
	}
	else
	{
		positionnumber--;
	}
	return functionlist[positionnumber];
}

basefunction *transxstate::getnextfunction(int positionnumber)
{
	if (positionnumber<0 || positionnumber>=NUMFUNCTIONS) return NULL;
	if (positionnumber==NUMFUNCTIONS-1)
	{
		positionnumber=0;
	}
	else
	{
		positionnumber++;
	}
	return functionlist[positionnumber];
}


transxstate::~transxstate()
{
	for (int a=0;a<NUMFUNCTIONS;a++)
	{
		delete functionlist[a];
		functionlist[a]=NULL;
		delete todeletelist[a];
		todeletelist[a]=NULL;
	}
}


bool transxstate::doupdate(HDC hDC, int tw, int th,int currfunction,int currview, int curvarfunction, int currvarview,TransxMFD *tmfdpointer)
{
	saveflag=false;//Part of system that allows only one save to take place
	int presentposition=(currfunction+fnbaseposition-1)%NUMFUNCTIONS;
	int presentvarposition=(curvarfunction+fnbaseposition-1)%NUMFUNCTIONS;
	class basefunction *cfunction=functionlist[presentposition];
	class basefunction *cvarfunction=functionlist[presentvarposition];
	if (cfunction==NULL)//shouldn't happen
	{
		cfunction=functionlist[fnbaseposition];
	}
	if (cvarfunction==NULL)
	{
		cvarfunction=functionlist[fnbaseposition];
	}
	if (currcalcfunction==-1) addaction(0);
	mfdpointer=tmfdpointer;
	int linespacing=th/24;
	if (mappointer==NULL) return false; //Just don't do anything if system not initialised
	if (mappointer->getinitialised()==false)
	{//show the Easter eggs!

		TextOut(hDC,tw/3,6*linespacing,"TransX",6);
		TextOut(hDC,0,22*linespacing,"(C) Sirius Cybernetics Corporation.",35);

		switch (eastereggswitch)
		{
		case 0:
			TextOut(hDC,tw/6,9*linespacing,"Change your world.",18);
			return false;
		case 1:
			TextOut(hDC,tw/6,9*linespacing,"It doesn't do dishes.",21);
			TextOut(hDC,tw/6,10*linespacing,"Sorry.",6);
			return false;
		case 2:
			TextOut(hDC,tw/6,8*linespacing,"Check out our new robotics",26);
			TextOut(hDC,tw/6,9*linespacing,"range.",6);
			TextOut(hDC,tw/6,11*linespacing,"Your plastic pal who's",22);
			TextOut(hDC,tw/6,12*linespacing,"fun to be with!",15);
			return false;
		case 3:
			TextOut(hDC,tw/6,8*linespacing,"Blue sky thinking -",19);
			TextOut(hDC,tw/6,9*linespacing,"we look down on it",18);
			return false;
		case 4:
			TextOut(hDC,tw/6,9*linespacing,"Change your world.",18);
			return false;
		}
		return false;
	}
	if (cfunction==NULL) 
	{//create a current function
		if (!initfunctions()) return false;//returns if it fails to create one
		cfunction=cvarfunction=functionlist[fnbaseposition];
	}
	initflag=true;
	if (helpsystem)
	{
		char help1[40],help2[40],help3[40],help4[40],help5[40];
		//Help for variable
		MFDvariable *variable;
		variable=cvarfunction->getcurrentvariable(currvarview);
		if (variable!=NULL)
		{
			variable->gethelpstrings(help1,help2);
			TextOut(hDC,0,11*linespacing,help1,strlen(help1));
			TextOut(hDC,0,12*linespacing,help2,strlen(help2));
		}
		//Help for function
		cfunction->gethelp(help1,help2,help3,help4,help5);
		TextOut(hDC,0,16*linespacing,help1,strlen(help1));
		TextOut(hDC,0,17*linespacing,help2,strlen(help2));
		TextOut(hDC,0,18*linespacing,help3,strlen(help3));
		TextOut(hDC,0,19*linespacing,help4,strlen(help4));
		TextOut(hDC,0,20*linespacing,help5,strlen(help5));
	}
	else
	{
		cfunction->processvisiblevars();//Update any visibility changes
		cfunction->doupdate(hDC,tw,th,currview);
	}
	char buffer[20];
	int length=sprintf(buffer,"Stage %i:%i",currfunction,numfunctions);
	TextOut(hDC,tw/2,0,buffer,length);
	length=sprintf(buffer,"Vars Stage %i",curvarfunction);
	TextOut(hDC,tw/2,4*linespacing,buffer,length);
	return true;
}
